From e8016f0c521df0b5ce64a3757d07cb9d63949f11 Mon Sep 17 00:00:00 2001
From: Luke Leighton <lkcl@lkcl.net>
Date: Sun, 12 Sep 2010 13:19:38 +0100
Subject: [PATCH 08/34] use event listener class GMWevents for login/out notification

---
 gnumed/gnumed/client/ProxiedWeb/gui/GMWevents.py  |   11 +++++++++++
 gnumed/gnumed/client/ProxiedWeb/gui/GNUmedWeb.py  |   12 ++++++++++++
 gnumed/gnumed/client/ProxiedWeb/gui/LoginPanel.py |    5 +++--
 3 files changed, 26 insertions(+), 2 deletions(-)
 create mode 100644 gnumed/gnumed/client/ProxiedWeb/gui/GMWevents.py

diff --git a/gnumed/gnumed/client/ProxiedWeb/gui/GMWevents.py b/gnumed/gnumed/client/ProxiedWeb/gui/GMWevents.py
new file mode 100644
index 0000000..5aea93d
--- /dev/null
+++ b/gnumed/gnumed/client/ProxiedWeb/gui/GMWevents.py
@@ -0,0 +1,11 @@
+from pyjamas.EventController import Handler
+
+class GNUmedEvents(object):
+    def __init__(self, app):
+        self.login = Handler(self, "Login", app)
+
+events = None
+
+def init_events(app):
+    global events
+    events = GNUmedEvents(app)
diff --git a/gnumed/gnumed/client/ProxiedWeb/gui/GNUmedWeb.py b/gnumed/gnumed/client/ProxiedWeb/gui/GNUmedWeb.py
index 073b2b8..7eb46cd 100644
--- a/gnumed/gnumed/client/ProxiedWeb/gui/GNUmedWeb.py
+++ b/gnumed/gnumed/client/ProxiedWeb/gui/GNUmedWeb.py
@@ -10,10 +10,16 @@ import jsonobjproxy # just to get it in for pyjs
 from LoginPanel import cLoginPanel
 from MainPanel import cMainPanel
 
+import GMWevents
+
 #======================================================
 class gmTopLevelLayer:
     
     def onModuleLoad(self):
+
+        GMWevents.init_events(self)
+        GMWevents.events.addLoginListener(self) # want to receive onLogin
+
         self.TEXT_ERROR = "Server Error"
         self.remote_py = EchoServicePython()
         self.loginpanel = cLoginPanel(self) # fires logged out on UI load
@@ -24,6 +30,12 @@ class gmTopLevelLayer:
 
         RootPanel().add(self.maindisplay)
 
+    def onLogin(self, sender, app, username, logged_in):
+        if logged_in:
+            self.logged_in(username)
+        else:
+            self.logged_out()
+
     def logged_out(self):
         self.login_username = None
         self.loginpanel.setStatus("") # reset status display
diff --git a/gnumed/gnumed/client/ProxiedWeb/gui/LoginPanel.py b/gnumed/gnumed/client/ProxiedWeb/gui/LoginPanel.py
index b8e3378..d92317f 100644
--- a/gnumed/gnumed/client/ProxiedWeb/gui/LoginPanel.py
+++ b/gnumed/gnumed/client/ProxiedWeb/gui/LoginPanel.py
@@ -1,4 +1,5 @@
 from pyjamas.builder.Builder import Builder, HTTPUILoader
+import GMWevents
 
 #======================================================
 class cLoginPanel: 
@@ -11,7 +12,7 @@ class cLoginPanel:
     def onUILoaded(self, text):
         self.b = Builder(text)
         self.lp = self.b.createInstance("LoginPanel", self)
-        self.app.logged_out() # start at logged out
+        GMWevents.events.onLoginEvent(self, None, False) # indicate logged out
 
     def setStatus(self, txt):
         if self.lp is not None:
@@ -40,7 +41,7 @@ class cLoginPanel:
                 # XXX response should really contain the username
                 self.setStatus("Login successful: %s" %str(response))
                 user = self.try_user
-                self.app.logged_in(user)
+                GMWevents.events.onLoginEvent(self, user, True) 
                 self.setStatus("Connected as: %s" % user)
             else:
                 self.setStatus("Login failed: %s" %str(response))
-- 
1.7.1

